#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 1e3 + 10;
const ll MAXM = 1e4 + 10;
const ll INF = 4e18 + 10;

struct edge
{
    ll u,v,cost;
    edge()
    {
        u = v = 1;
        cost = 0;
    }
    edge(ll _u, ll _v, ll _cost)
    {
        u = _u;
        v = _v;
        cost = _cost;
    }
};

ll n,m;
ll dp[MAXN][MAXM];
ll ans[MAXM];
vector < edge > edges;

void read()
{
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        ll u,v,cost;
        cin >> u >> v >> cost;
        edge e(u,v,cost);
        edges.push_back(e);
    }
}

void init()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 0; j <= m; j++)
        {
            dp[i][j] = INF;
        }
    }
    dp[1][0] = 0;
}

void solve()
{
    for(int j = 1; j <= m; j++)
    {
        for(edge e : edges)
        {
            ll u = e.u;
            ll v = e.v;
            ll cost = e.cost;

            if(dp[u][j - 1] < cost)
            {
                dp[v][j] = min(dp[v][j], cost);
                ans[v] = j;
            }

            if(dp[v][j - 1] < cost)
            {
                dp[u][j] = min(dp[u][j], cost);
                ans[u] = j;
            }
        }
    }
}

void print()
{
    for(int i = 1; i <= n; i++)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    init();
    solve();
    print();

    return 0;
}
