#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 1e3 + 10;
const ll MAXN2 = 1e5 + 10;
const ll MAXM = 1e4 + 10;
const ll INF = 4e18 + 10;

struct edge
{
    ll u,v,cost;
    edge()
    {
        u = v = 1;
        cost = 0;
    }
    edge(ll _u, ll _v, ll _cost)
    {
        u = _u;
        v = _v;
        cost = _cost;
    }
};

struct dest
{
    ll u, last, cnt;
    dest()
    {
        u = 1;
        last = 0;
        cnt = 0;
    }
    dest(ll _u, ll _last, ll _cnt)
    {
        u = _u;
        last = _last;
        cnt = _cnt;
    }
    bool operator<(const dest&d)const
    {
        return last < d.last;
    }
};

ll n,m;
ll dp[MAXN][MAXM];
ll ans[MAXN2];
vector < edge > edges;
vector < edge > adj[MAXN2];

void read()
{
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        ll u,v,cost;
        cin >> u >> v >> cost;
        edge e(u,v,cost);
        edges.push_back(e);
        adj[u].push_back(e);
        swap(e.u, e.v);
        adj[v].push_back(e);
    }
}

void init()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 0; j <= m; j++)
        {
            dp[i][j] = INF;
        }
    }
    dp[1][0] = 0;
}

void solve_dp()
{
    for(int j = 1; j <= m; j++)
    {
        for(edge e : edges)
        {
            ll u = e.u;
            ll v = e.v;
            ll cost = e.cost;

            if(dp[u][j - 1] < cost)
            {
                dp[v][j] = min(dp[v][j], cost);
                ans[v] = j;
            }

            if(dp[v][j - 1] < cost)
            {
                dp[u][j] = min(dp[u][j], cost);
                ans[u] = j;
            }
        }
    }
}

void dfs(ll u, ll last, ll cnt)
{
    ans[u] = cnt;
    for(edge e : adj[u])
    {
        if(e.cost > last)
            dfs(e.v, e.cost, cnt + 1);
    }
}

void solve_tree()
{
    dfs(1, 0, 0);
}

void solve_dijkstra()
{
    priority_queue < dest > pq;
    pq.push(dest());
    ll ops = 0;
    while(!pq.empty())
    {
        dest curd = pq.top();
        pq.pop();
        ll u = curd.u;
        ll last = curd.last;
        ll cnt = curd.cnt;
        ans[u] = max(ans[u], cnt);

        for(edge e : adj[u])
        {
            ops++;
            ll v = e.v;
            ll cost = e.cost;

            if(cost > last && cnt + 1 > ans[v])
            {
                pq.push(dest(v, cost, cnt + 1));
            }
        }
    }
}

void print()
{
    for(int i = 1; i <= n; i++)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
}

void solve()
{
     solve_dijkstra();
     /**
    if(m == n - 1)
    {
        solve_tree();
    }
    else
    {
        init();
        solve_dp();
    }
    */
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
    print();

    return 0;
}
