#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5 * 1e5 + 1;
const int MAXM = 2 * 1e6 + 1;
int N, Q;
set<int> A[MAXN];
int Visited_Left[MAXM];
int Visited_Right[MAXM];
int Mark;
vector<pair<int, int>> Pairs;
map<set<int>, vector<int>> G;
vector<int> Graph[MAXN];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;

    for(int i = 1; i <= N; i++)
    {
        int Size;
        cin >> Size;

        for(int j = 0; j < Size; j++)
        {
            int X;
            cin >> X;
            A[i].insert(X);

            if(j < Size - 1)
            {
                G[A[i]].push_back(i);
            }
        }
    }

    for(int i = 1; i <= N; i++)
    {
        for(auto& U : G[A[i]])
        {
            Graph[i].push_back(U);
        }
    }
}

bool F(int i, int j, int Type)
{
    if(Type == 0)
    {
        for(auto& X : A[j])
        {
            if(Visited_Left[X] != Mark)
            {
                return true;
            }
        }
    }
    else
    {
        for(auto& X : A[j])
        {
            if(Visited_Right[X] != Mark)
            {
                return true;
            }
        }
    }

    return false;
}

bool Check(int left, int right)
{
    if(left == 1 && right == N)
    {
        return true;
    }

    int l = left, r = right;

    for(int i = left; i <= right; i++)
    {
        for(auto& X : A[i])
        {
            Visited_Left[X] = Mark;
            Visited_Right[X] = Mark;
        }
    }

    left--;

    while(left > 0)
    {
        bool Able = false;

        for(auto& X : A[left])
        {
            if(Visited_Left[X] != Mark)
            {
                Able = true;
            }

            Visited_Left[X] = Mark;
        }

        if(!Able)
        {
            return false;
        }

        for(auto& j : Graph[left])
        {
            if(left == j || j >= l && j <= r)
            {
                continue;
            }

            if(!F(left, j, 0))
            {
                return false;
            }
        }

        left--;
    }

    right++;

    while(right <= N)
    {
        bool Able = false;

        for(auto& X : A[right])
        {
            if(Visited_Right[X] != Mark)
            {
                Able = true;
            }

            Visited_Right[X] = Mark;
        }

        if(!Able)
        {
            return false;
        }

        for(auto& j : Graph[right])
        {
            if(right == j || j >= l && j <= r)
            {
                continue;
            }

            if(!F(right, j, 1))
            {
                return false;
            }
        }

        right++;
    }

    return true;
}

void Solve()
{
    cin >> Q;

    while(Q--)
    {
        int left, right;
        cin >> left >> right;
        Mark++;

        if(Check(left, right))
        {
            cout << 1 << '\n';
        }
        else
        {
            cout << 0 << '\n';
        }
    }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
