# include <iostream>
# include <vector>
# include <algorithm>
# include <set>
using namespace std;

const int MAXK=1e6+11,MAXN=3e3+11,INF=1e9;
vector<int> a[MAXN];
vector<int> col[MAXK];
vector<int> pos[MAXN];
int le[MAXN];
int ri[MAXN];
int n,q;

void reset()
{
    for(int i=1;i<=n;i++)
    {
        le[i]=INF;
        ri[i]=0;
    }
}

void precomp()
{
    reset();
    for(int i=1;i<=n;i++)
    {
        int id=-1;
        for(int k: a[i])
        {
            id++;
            int p=pos[i][id];

            ///nalqvo
            if(p==0) le[i]=min(le[i],1);
            else le[i]=min(le[i],col[k][p-1]+1);

            ///nadqsno
            if(p==col[k].size()-1) ri[i]=max(ri[i],n);
            else ri[i]=max(ri[i],col[k][p+1]-1);
        }

        //cout<<i<<":"<<le[i]<<" "<<ri[i]<<"\n";
    }
}

bool dp[MAXN][MAXN];

void test_reset()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=i;j<=n;j++)
        {
            dp[i][j]=0;
        }
    }
}

void solve(int l, int r)
{
    dp[l][r]=1;
    if(l!=1 and !dp[l-1][r])
    {
        if(ri[l-1]>=r) solve(l-1,r);
    }

    if(r!=n and !dp[l][r+1])
    {
        if(le[r+1]<=l) solve(l,r+1);
    }
}

void test_solve()
{
    int l,r;
    cin>>l>>r;
    //test_reset();

    set<pair<int, int>> ls;
    set<pair<int, int>, greater<pair<int, int>>> rs;

    for(int i=1;i<l;i++)
    {
        ls.insert({ri[i],i});
    }

    for(int i=r+1;i<=n;i++)
    {
        rs.insert({le[i],i});
    }

    int br=10;
    while(true)
    {
        //br--;
        //if(br==0) break;
        //cout<<l<<" "<<r<<"\n";

        if((ls.size()==0 and rs.size()==0) or (l==1 and r==n)) {cout<<1<<"\n";return ;}

        int p,q;
        if(ls.size()==0) p=n;
        else p=(*(ls.begin())).first;

        if(rs.size()==0) q=1;
        else q=(*(rs.begin())).first;

        if(p<r or q>l) {cout<<0<<"\n";return ;}

        if(p!=n)
        {
            p=(*ls.begin()).second;
        }

        if(q!=1)
        {
            q=(*rs.begin()).second;
        }

        for(int i=p;i<l;i++)
        {
            if(ls.size()==0) break;
            ls.erase({ri[i],i});
        }

        for(int i=r+1;i<=q;i++)
        {
            if(rs.size()==0) break;
            rs.erase({le[i],i});
        }

        l=p;
        r=q;

        if(p==n) l=1;
        if(q==1) r=n;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++)
    {
        int br;
        cin>>br;

        while(br--)
        {
            int c;
            cin>>c;
            a[i].push_back(c);
            col[c].push_back(i);
            pos[i].push_back(col[c].size()-1);
        }
    }

    precomp();

    cin>>q;
    while(q--)
    {
        test_solve();
    }

    return 0;
}
/*
6
2 5 3
1 4
1 1
1 2
2 3 4
1 6
1
3 4
*/

