# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
# include <tuple>
using namespace std;

struct edge
{
    int x, y, c;
};

const int MAXM=1e4+11,MAXN=1e3+11;
vector<edge> v;
vector<pair<int, int>> a[MAXM];
int n,m;

bool cmp(edge p, edge q)
{
    return p.c<q.c;
}

void Read()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int x,y,c;
        cin>>x>>y>>c;

        v.push_back({x,y,c});
    }

    sort(v.begin(),v.end(),cmp);

    int curr=-1;
    int br=0;
    for(edge e: v)
    {
        int d=0;
        if(e.c==curr) d=br;
        else
        {
            curr=e.c;
            br++;
            d=br;
        }

        //cout<<e.x<<" "<<e.y<<" "<<d<<"\n";

        a[e.x].push_back({e.y,d});
        a[e.y].push_back({e.x,d});
    }
}

int dist[MAXN][MAXM];

void Solve()
{
    priority_queue<tuple<int, int, int>> q;
    dist[1][0]=0;
    q.push(make_tuple(0,0,1));
    while(q.size()>0)
    {
        int d, vr, curr;
        tie(d,vr,curr)=q.top();
        vr=-vr;
        q.pop();

        //cout<<"-->"<<curr<<" "<<vr<<" "<<d<<"\n";

        if(dist[curr][vr]>d) continue;

        for(pair<int, int> nxt: a[curr])
        {
            //cout<<curr<<"->"<<nxt.first<<" "<<nxt.second<<"\n";
            if(nxt.second<=vr) continue;
            if(dist[nxt.first][nxt.second]<d+1)
            {
                dist[nxt.first][nxt.second]=d+1;
                q.push(make_tuple(d+1,-nxt.second,nxt.first));
            }
        }
    }

    for(int i=1;i<=n;i++)
    {
        int ans=0;
        for(int j=1;j<=m;j++) ans=max(ans,dist[i][j]);

        cout<<ans<<" ";
    }
    cout<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Read();
    Solve();

    return 0;
}
