# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
# include <tuple>
using namespace std;

struct edge
{
    int x, y, c;
};

const int MAXM=1e6+11,MAXN=1e5+11;
vector<edge> v;
vector<pair<int, int>> a[MAXM];
int n,m;

bool cmp(edge p, edge q)
{
    return p.c<q.c;
}

void Read()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int x,y,c;
        cin>>x>>y>>c;

        if(x>y) swap(x,y);
        v.push_back({x,y,c});
    }

    sort(v.begin(),v.end(),cmp);
}

int dp[MAXN];

void Solve()
{
    for(int i=1;i<=n;i++) dp[i]=-1;

    for(edge e: v)
    {
        //cout<<e.x<<" "<<e.y<<"\n";

        int st1=dp[e.x];
        int st2=dp[e.y];
        if(dp[e.x]!=-1) st2=max(dp[e.y],dp[e.x]+1);
        if(dp[e.y]!=-1) st1=max(dp[e.x],dp[e.y]+1);

        dp[e.x]=st1;
        dp[e.y]=st2;

        if(e.x==1)
        {
            dp[1]=max(0,dp[1]);
            dp[e.y]=max(dp[e.y],1);
        }

        //cout<<"->"<<dp[e.x]<<" "<<dp[e.y]<<"\n";
    }

    for(int i=1;i<=n;i++) cout<<dp[i]<<" ";
    cout<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Read();
    Solve();

    return 0;
}

