# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
# include <tuple>
using namespace std;

struct edge
{
    long long x, y, c;
};

const int MAXM=1e6+11,MAXN=1e6+11;
vector<edge> v;
int n,m;

bool cmp(edge p, edge q)
{
    return p.c<q.c;
}

void Read()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        long long x,y,c;
        cin>>x>>y>>c;

        if(x>y) swap(x,y);
        v.push_back({x,y,c});
    }

    sort(v.begin(),v.end(),cmp);
}

long long dp[MAXN];
long long dp2[MAXN];

void Solve()
{
    for(int i=1;i<=n;i++) dp[i]=dp2[i]-1;

    int st=v[0].c;
    vector<edge> curr;
    for(int i=0;i<m;i++)
    {
        if(v[i].c==st) curr.push_back(v[i]);
        else
        {
            for(edge e: curr)
            {
                if(dp[e.x]!=-1) dp2[e.y]=max(dp2[e.y],dp[e.x]+1);
                if(dp[e.y]!=-1) dp2[e.x]=max(dp2[e.x],dp[e.y]+1);

                if(e.x==1)
                {
                    dp2[e.x]=max(0LL,dp[e.x]);
                    dp2[e.y]=max(dp[e.y],1LL);
                }
            }

            for(edge e: curr)
            {
                dp[e.x]=max(dp[e.x],dp2[e.x]);
                dp[e.y]=max(dp[e.y],dp2[e.y]);
            }

            curr.clear();
            curr.push_back(v[i]);
            st=v[i].c;
        }



        //cout<<"->"<<dp[e.x]<<" "<<dp[e.y]<<"\n";
    }

    if(curr.size()>0)
    {
        for(edge e: curr)
        {
            if(dp[e.x]!=-1) dp2[e.y]=max(dp2[e.y],dp[e.x]+1);
            if(dp[e.y]!=-1) dp2[e.x]=max(dp2[e.x],dp[e.y]+1);

            if(e.x==1)
            {
                dp2[e.x]=max(0LL,dp[e.x]);
                dp2[e.y]=max(dp[e.y],1LL);
            }
        }

        for(edge e: curr)
        {
            dp[e.x]=max(dp[e.x],dp2[e.x]);
            dp[e.y]=max(dp[e.y],dp2[e.y]);
        }
    }

    for(int i=1;i<=n;i++)
    {
        if(dp[i]==-1) cout<<0<<" ";
        else cout<<dp[i]<<" ";
    }
    cout<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Read();
    Solve();

    return 0;
}
/*
4 4
1 2 1
2 3 2
3 4 3
4 1 4
*/
