#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <map>
using namespace std;

map <pair <int, int>, int> dp;
vector <vector <pair <int, int> > > gr;

void calcdp (int par, int p, int time) {
    if (par == 1) {
        dp[{par, p}] = 1;
        return;
    }

    int bst = 0;
    for (pair <int, int> e : gr[par])
        if (e.second < time) {
            if (dp[{e.first, par}] == 0)
                calcdp (e.first, par, e.second);
            
            bst = max (bst, dp[{e.first, par}]);
        }
    
    if (bst == 0)
        dp[{par, p}] = bst;
    else
        dp[{par, p}] = bst + 1;
}

int main () {
    ios::sync_with_stdio (false);
    cin.tie (0);
    cout.tie (0);

    int n = 0, m = 0;
    cin >> n >> m;

    gr.resize (n + 1);
    for (int i = 1; i <= m; i++) {
        int a = 0, b = 0, c = 0;
        cin >> a >> b >> c;

        gr[a].push_back ({b, c});
        gr[b].push_back ({a, c});
    }
    
    for (int i = 1; i <= n; i++) {
        int m = 0;
        for (pair <int, int> e : gr[i]) {
            if (dp[{e.first, i}] == 0)
                calcdp (e.first, i, e.second);
            m = max (dp[{e.first, i}], m);
        }

        cout << m << ' ';
    }
}