#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int numberOnSegment(const vector<int> &arr, int l, int r) {
    // Number on [l, r]
    if (l > r) {return 0;}
    return upper_bound(arr.begin(), arr.end(), r) - upper_bound(arr.begin(), arr.end(), l - 1);
}

signed main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> cols;
    for (int i = 0; i < n; ++i) {
        int ki;
        cin >> ki;
        a[i].resize(ki);
        for (int j = 0; j < ki; ++j) {
            cin >> a[i][j];
            cols.push_back(a[i][j]);
        }
    }
    sort(cols.begin(), cols.end());
    cols.resize(unique(cols.begin(), cols.end()) - cols.begin());
    for (int i = 0; i < n; ++i) {
        for (auto &c : a[i]) {
            c = lower_bound(cols.begin(), cols.end(), c) - cols.begin();
        }
    }
    // For each color save positions (in sorted order) where is this color.
    vector<vector<int>> pos(cols.size());
    for (int i = 0; i < n; ++i) {
        for (int j : a[i]) {
            pos[j].push_back(i);
        }
    }
    // For each i save minimal j, when i can be added after a segment [i+1, j]
    vector<int> bR(n), bL(n);
    for (int i = 0; i < n; ++i) {
        int L = i, R = n;
        while (R - L > 1) {
            int M = (L + R) / 2;
            bool fl = false;
            for (int c : a[i]) {
                if (numberOnSegment(pos[c], i + 1, M) == 0) {
                    fl = true;
                    break;
                }
            }
            if (fl) {
                L = M;
            } else {
                R = M;
            }
        }
        bR[i] = L;
    }
    for (int i = 0; i < n; ++i) {
        int L = -1, R = i;
        while (R - L > 1) {
            int M = (L + R) / 2;
            bool fl = false;
            for (int c : a[i]) {
                if (numberOnSegment(pos[c], M, i - 1) == 0) {
                    fl = true;
                    break;
                }
            }
            if (fl) {
                R = M;
            } else {
                L = M;
            }
        }
        bL[i] = R;
    }
    int q;
    cin >> q;
    for (int t = 0; t < q; ++t) {
        vector<vector<bool>> dp(n, vector<bool>(n));
        int ls, rs;
        cin >> ls >> rs;
        dp[ls - 1][rs - 1] = true;
        for (int sz = rs - ls + 2; sz <= n; ++sz) {
            for (int l = 0; l + sz - 1 < n; ++l) {
                int r = l + sz - 1;
                if (bR[l] >= r) {
                    dp[l][r] = dp[l][r] || dp[l + 1][r];
                }
                if (bL[r] <= l) {
                    dp[l][r] = dp[l][r] || dp[l][r - 1];
                }
            }
        }
        cout << dp[0][n - 1] << "\n";
    }
}