#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
struct edge {
    int to, w, ind;
};
struct edge2 {
    int x, y, w, ind1, ind2;
};
bool cmp(edge a, edge b) {
    return a.w < b.w || (a.w == b.w && a.to < b.to);
}
bool cmp2(edge2 a, edge2 b) {
    return a.w < b.w;
}

const int N = 100000;
int n, m;
vector<edge> g[N];
vector<vector<int>> gr;

void solve() {
    cin >> n >> m;
    vector<edge2> edges;
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        --x, --y;
        g[x].push_back({ y, w, (int)gr.size()});
        gr.push_back({});
        g[y].push_back({ x, w, (int)gr.size()});
        gr.push_back({});
        edges.push_back({ x, y, w, (int)gr.size() - 2, (int)gr.size() - 1 });
    }
    for (int v = 0; v < n; ++v) {
        sort(g[v].begin(), g[v].end(), cmp);
        for (int i = 0; i < g[v].size() - 1; ++i) {
            if (g[v][i].w == g[v][i + 1].w) continue;
            gr[g[v][i].ind].push_back(g[v][i + 1].ind);
        }
    }
    sort(edges.begin(), edges.end(), cmp2);
    vector<int> dpnw(gr.size(), -1), dp(gr.size(), -1);
    for (auto to : g[0]) dp[to.ind] = 0;
    for (int i = 0; i < edges.size(); ++i) {
        int v = edges[i].ind1, u = edges[i].ind2;
        if (!i || edges[i].w > edges[i - 1].w) {
            dp[v] = max(dp[v], dpnw[v]);
            dp[u] = max(dp[u], dpnw[u]);
            bool f1 = dp[u] != -1, f2 = dp[v] != -1;
            int dpv = dp[v];
            if (f1) dp[v] = max(dp[v], dp[u] + 1);
            if (f2) dp[u] = max(dp[u], dpv + 1);
            for (auto to : gr[v]) {
                dp[to] = max({ dpnw[to], dp[to], dp[v] });
            }
            for (auto to : gr[u]) {
                dp[to] = max({ dpnw[to], dp[to], dp[u] });
            }
        }
        else {
            bool f1 = dp[u] != -1, f2 = dp[v] != -1;
            int dpv = dp[v];
            if (f1) dpnw[v] = max(dp[v], dp[u] + 1);
            if (f2) dpnw[u] = max(dp[u], dpv + 1);
            for (auto to : gr[v]) {
                dpnw[to] = max(dpnw[to], dp[v]);
            }
            for (auto to : gr[u]) {
                dpnw[to] = max(dpnw[to], dp[u]);
            }
        }
    }
    for (int v = 0; v < n; ++v) {
        int ans = 0;
        for (auto r : g[v]) {
            ans = max(ans, max(dpnw[r.ind], dp[r.ind]));
        }
        cout << ans << ' ';
    }
}



signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}
