#include "twins.h"

using namespace std;

vector<int> play1(int n, int t) {
	int l = 1;
	int r = n;

	while (r - l > 1) {
		int m = l + (r - l) / 2;
		vector<vector<int>> questions;

		if (l == m)
			questions = {{l}};
		else
			questions = {{l, m}};

		string answer = guess(questions);

		if (answer[0] == '1')
			r = m;
		else
			l = m + 1;
	}

	if (r - l == 1) {
		vector<vector<int>> questions = {
			{l}
		};
		string answer = guess(questions);

		if (answer[0] == '1')
			r = l;
	}

	return {r};
}

vector<int> play2(int n, int t) {
	int l1 = 1, r1 = n;
	int l2 = 1, r2 = n;

	while (r1 - l1 > 1 || r2 - l2 > 1) {
		if (l1 == l2 && r1 == r2) {
            int m = l1 + (r1 - l1) / 2;
            vector<vector<int>> questions = {
				{l1, m},
				{m + 1, r1}
            };
			string answer = guess(questions);

			if (answer[0] == '1' && answer[1] == '1') {
				r1 = m;
				l2 = m + 1;
			}
			else if (answer[0] == '1') {
				r1 = m;
				r2 = m;
			}
			else {
				l1 = m + 1;
				l2 = m + 1;
			}
		}
		else if (r1 - l1 > 1 || r2 - l2 > 1) {
			int m1 = l1 + (r1 - l1) / 2;
			int m2 = l2 + (r2 - l2) / 2;
			vector<vector<int>> questions = {
				{l1, m1},
				{l2, m2}
			};
			string answer = guess(questions);

			if (answer[0] == '1')
                r1 = m1;
			else
				l1 = m1 + 1;

			if (answer[1] == '1')
				r2 = m2;
			else
				l2 = m2 + 1;
		}
		else if (r1 - l1 > 1) {
			int m = l1 + (r1 - l1) / 2;
			vector<vector<int>> questions = {
				{l1, m}
			};
			string answer = guess(questions);

			if (answer[0] == '1')
				r1 = m;
			else
				l1 = m + 1;
		}
		else {
			int m = l2 + (r2 - l2) / 2;
			vector<vector<int>> questions = {
				{l2, m}
			};
			string answer = guess(questions);

			if (answer[0] == '1')
				r2 = m;
			else
				l2 = m + 1;
		}
	}

	vector<int> result;

	if (r1 - l1 == 1 && r2 - l2 == 1) {
		vector<vector<int>> questions = {
			{l1},
			{l2}
		};
		string answer = guess(questions);

        if (answer[0] == '1')
			result.push_back(l1);
		else
			result.push_back(r1);
		if (answer[1] == '1')
			result.push_back(l2);
		else
			result.push_back(r2);
	}
	else if (r1 - l1 == 1) {
		vector<vector<int>> questions = {
			{l1},
		};
		string answer = guess(questions);

		if (answer[0] == '1')
			result.push_back(l1);
		else
			result.push_back(r1);

		result.push_back(r2);
	}
	else {
		result.push_back(r1);

		vector<vector<int>> questions = {
			{l2},
		};
		string answer = guess(questions);

		if (answer[0] == '1')
			result.push_back(l2);
		else
			result.push_back(r2);
	}

	return result;
}

vector<int> play(int n, int t) {
	if (t == 1)
		return play1(n, t);
	else
		return play2(n, t);
}
