#include <twins.h>
#include <vector>
#include <iostream>

using namespace std;

//Guess Method Example: string guess(vector<vector<int>> questions);

vector<vector<int>> dividePhotos(vector<int> avaiblePhotos) {
	vector<vector<int>> nextPairs(2);
	int n = avaiblePhotos.size();
	if (n % 2 == 0) {
		for (int i = 0; i < n / 2; i++) nextPairs[0].push_back(avaiblePhotos[i]);
		for (int i = n / 2; i < n; i++) nextPairs[1].push_back(avaiblePhotos[i]);
	}
	else {
		for (int i = 0; i < n / 2 + 1; i++) nextPairs[0].push_back(avaiblePhotos[i]);
		for (int i = n / 2 + 1; i < n; i++) nextPairs[1].push_back(avaiblePhotos[i]);
	}

	return nextPairs;
}

vector<vector<int>> getNextPairs(vector<vector<int>> prevPairs, string filter) {
	vector<vector<int>> res, temp;
	for (int i = 0; i < filter.length(); i++) {
		if (filter[i] == '1') {
			temp = dividePhotos(prevPairs[i]);
			for (vector<int> v : temp) res.push_back(v);
		}
	}

	return res;
}

vector<int> play(int N, int T) {
	vector<int> allPhotos(N);
	for (int i = 0; i < N; i++) allPhotos[i] = i + 1;

	vector<vector<int>> nextPairs = dividePhotos(allPhotos);
	string guessingResult;
	while (guessingResult.length() != T && nextPairs[0].size() != 1 && nextPairs[1].size() != 1) {
		guessingResult = guess(nextPairs);
		nextPairs = getNextPairs(nextPairs, guessingResult);
	}

	vector<int> result(T);
	for (int i = 0; i < T; i++) result[i] = nextPairs[i][0];
	return result;
}