#include <iostream>
#include <cassert>
#include <cmath>
#include <algorithm>
#include "twins.h"

#define debug(x) #x << " = " << x << '\n'

std::vector<int> play(int n, int T) {
  auto t1 = [&] (std::vector<int> cand) {
    int n = (int) cand.size();
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> Q(logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 0; i < n; i++) {
        if ((i >> j) & 1) {
          Q[j].push_back(cand[i]);
        }
      }
    }
    std::string str = guess(Q);
    int ret = 0;
    for (int j = 0; j < logN; j++) {
      if (str[j] == '1') {
        ret |= (1 << j);
      }
    }
    return cand[ret];
  };

  if (T == 1) {
    std::vector<int> all;
    for (int i = 1; i <= n; i++) {
      all.push_back(i);
    }
    return {t1(all)};
  } else {
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> Q(2 * logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if ((i >> j) & 1) {
          Q[j].push_back(i);
        }
      }
    }
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if (!((i >> j) & 1)) {
          Q[j + logN].push_back(i);
        }
      }
    }

    std::string s = guess(Q);

    int differ = -1;
    int v1 = 0, v2 = 0;
    for (int j = logN - 1; j >= 0 && differ == -1; j--) {
      if (s[j] == s[j + logN]) {
        differ = j;
        break;
      } else {
        if (s[j] == '1') {
          v1 |= (1 << j);
          v2 |= (1 << j);
        }
      }
    }
    assert(differ != -1);
//    std::cout << "! " << logN << ' ' << v1 << ' ' << v2 << ' ' << differ << '\n';
//    if (differ == 0) {
//      return {v1, v1 + 1};
//    }
    std::vector<int> cand, cand2;
    for (int i = 1; i <= n; i++) {
      int v = (i >> (differ - 0));
//      std::cout << "? " << i << ' ' << (v << 0) << '\n';
      if (((v >> 1) << (differ + 1)) == v1) {
        if (!(v & 1)) {
          cand.push_back(i);
        } else {
          cand2.push_back(i);
        }
      }
    }

//    std::cout << "cand1 ====== \n\n";
//    for (const auto &v : cand) {
//      std::cout << v << ' ';
//    }
//    std::cout << '\n';
//    std::cout << "cand2 ====== \n\n";
//    for (const auto &v : cand2) {
//      std::cout << v << ' ';
//    }
//    std::cout << '\n';

    v1 = t1(cand);
    v2 = t1(cand2);

    return {v1, v2};
  }
}


