#include <iostream>
#include <cassert>
#include <cmath>
#include <algorithm>
#include "twins.h"

#define debug(x) #x << " = " << x << '\n'

std::vector<int> play(int n, int T) {
  auto t1 = [&] (std::vector<int> cand) {
    int n = (int) cand.size();
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> Q(logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 0; i < n; i++) {
        if ((i >> j) & 1) {
          Q[j].push_back(cand[i]);
        }
      }
    }
    std::string str = guess(Q);
    int ret = 0;
    for (int j = 0; j < logN; j++) {
      if (str[j] == '1') {
        ret |= (1 << j);
      }
    }
    return cand[ret];
  };

  if (T == 1) {
    std::vector<int> all;
    for (int i = 1; i <= n; i++) {
      all.push_back(i);
    }
    return {t1(all)};
  } else {
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> Q(2 * logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if ((i >> j) & 1) {
          Q[j].push_back(i);
        }
      }
    }
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if (!((i >> j) & 1)) {
          Q[j + logN].push_back(i);
        }
      }
    }

    int where[logN][2];
    for (int differ = 0; differ < logN; differ++) {
      std::vector<int> cand, cand2;
      for (int i = 1; i <= n; i++) {
        int v = (i >> differ);
        if (v & 1) {
          cand2.push_back(i);
        } else {
          cand.push_back(i);
        }
      }
      where[differ][0] = (int) Q.size();
      Q.push_back(cand);
      where[differ][1] = (int) Q.size();
      Q.push_back(cand2);
    }

    std::string s = guess(Q);

    int differ = -1;
    for (int j = 0; j < logN; j++) {
      if (s[j] == s[j + logN]) {
        differ = j;
        break;
      }
    }

    int v1 = t1(Q[where[differ][0]]);
    int v2 = t1(Q[where[differ][1]]);

    return {v1, v2};
  }
}


