#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pi = array<int, 2>;
#define pb push_back

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int n;
  cin >> n;
  
  int maxc = 0;
  vector<int> k(n + 1);
  vector<vector<int>> a(n + 1);
  for (int i = 1; i <= n; ++i) {
    cin >> k[i];
    a[i].assign(k[i], 0);
    for (int j = 0; j < k[i]; ++j) cin >> a[i][j];
    
    maxc = max(maxc, *max_element(a[i].begin(), a[i].end()));
  }
  
  // right[i] - rightmost position such that if i take (i..right), i can still take i
  // left[i] - leftmost position such that if i take (left..i), i can still take i
  vector<int> last(maxc + 1, -1), right(n + 1, 0), left(n + 1, n + 1);
  for (int i = 1; i <= n; ++i) {
    for (int c : a[i]) {
      if (last[c] == -1) left[i] = 0;
      else left[i] = min(left[i], last[c]);
      last[c] = i;
    }
  }
  last.assign(maxc + 1, -1);
  for (int i = n; i >= 1; --i) {
    for (int c : a[i]) {
      if (last[c] == -1) right[i] = n + 1;
      else right[i] = max(right[i], last[c]);
      last[c] = i;
    }
  }
  
  // dp[i][j] - is it possible to take everything from [i..j]
  vector<vector<int>> dp(n + 1, vector<int>(n + 1, -1));
  function<bool(int, int)> calc = [&](int l, int r) -> bool {
    if (l == 1 && r == n) return true;
    if (dp[l][r] != -1) return dp[l][r];
    
    dp[l][r] = false;
    // take left
    if (l > 1 && right[l - 1] > r) dp[l][r] |= calc(l - 1, r);
    
    // take right
    if (r < n && left[r + 1] < l) dp[l][r] |= calc(l, r + 1);
    
    return dp[l][r];
  };
  
  int q;
  cin >> q;
  cout << endl << endl;
  while (q--) {
    int l, r;
    cin >> l >> r;
    cout << calc(l, r) << endl;
  }
}
