#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pi = array<int, 2>;
#define pb push_back

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int n;
  cin >> n;
  
  int maxc = 0;
  vector<int> k(n + 1);
  vector<vector<int>> a(n + 1);
  for (int i = 1; i <= n; ++i) {
    cin >> k[i];
    a[i].assign(k[i], 0);
    for (int j = 0; j < k[i]; ++j) cin >> a[i][j];
    
    maxc = max(maxc, *max_element(a[i].begin(), a[i].end()));
  }
  
  // right[i] - rightmost position such that if i take (i..right), i can still take i
  // left[i] - leftmost position such that if i take (left..i), i can still take i
  vector<int> last(maxc + 1, -1), right(n + 1, 0), left(n + 1, n + 1);
  for (int i = 1; i <= n; ++i) {
    for (int c : a[i]) {
      if (last[c] == -1) left[i] = 0;
      else left[i] = min(left[i], last[c]);
      last[c] = i;
    }
  }
  last.assign(maxc + 1, -1);
  for (int i = n; i >= 1; --i) {
    for (int c : a[i]) {
      if (last[c] == -1) right[i] = n + 1;
      else right[i] = max(right[i], last[c]);
      last[c] = i;
    }
  }
  
  vector<int> pref_right(n + 1, n + 1), suf_left(n + 2, 0);
  for (int i = 1; i <= n; ++i) pref_right[i] = min(pref_right[i - 1], right[i]);
  for (int i = n; i >= 1; --i) suf_left[i] = max(suf_left[i + 1], left[i]);
  
  int q;
  cin >> q;
  cout << endl << endl;
  while (q--) {
    int l, r;
    cin >> l >> r;
    
    int iter = 0;
    if (pref_right[l - 1] <= r) iter = n + 11;
    if (suf_left[r + 1] >= l) iter = n + 11;
    
    while (l != 1 || r != n) {
      ++iter;
      if (iter > n + 10) break;
      
      //cout << l << " " << r << " | " << suf_left[r + 1] << " " << pref_right[l - 1] << endl;
      
      // take left
      while (l > 1 && suf_left[r + 1] < l - 1) --l;

      //cout << l << " " << r << " | " << suf_left[r + 1] << " " << pref_right[l - 1] << endl;
      
      // take right
      while (r < n && pref_right[l - 1] > r + 1) ++r;
      
      //cout << l << " " << r << " | " << suf_left[r + 1] << " " << pref_right[l - 1] << endl;
    }
    
    if (l != 1 || r != n) cout << "0\n";
    else cout << "1\n";
  }
}

/*
6
2 5 3
1 4
1 1
1 2
2 3 4
1 6
1
5 5
*/
