#include <bits/stdc++.h>
using namespace std;

using ll = long long;
//#define int ll
using pi = array<int, 2>;
#define pb push_back

const int INF = 1e9;

struct Edge {
  int u, v, c;
};

int32_t main() {
  int n, m;
  cin >> n >> m;
  
  vector<vector<int>> adj(n + 1);
  vector<Edge> edges;
  for (int i = 0; i < m; ++i) {
    Edge e;
    cin >> e.u >> e.v >> e.c;

    adj[e.u].pb(edges.size());
    edges.pb(e);

    swap(e.u, e.v);
    
    adj[e.u].pb(edges.size());
    edges.pb(e);
  }
  m = edges.size();
  for (int i = 1; i <= n; ++i) {
    sort(adj[i].begin(), adj[i].end(), [&](int x, int y) {
      return edges[x].c > edges[y].c;
    });
  }
  
  vector<int> dist(m, INF);
  priority_queue<pi,vector<pi>,greater<pi>> q{};
  for (int i = 0; i < m; ++i) {
    if (edges[i].u == 1) {
      dist[i] = -1;
      q.push({-1, i});
    }
  }
  
  while (!q.empty()) {
    auto [d, idx] = q.top();
    q.pop();
    if (d != dist[idx]) continue;
    
    for (int other : adj[edges[idx].v]) {
      if (edges[other].c <= edges[idx].c) break;
      if (d - 1 < dist[other]) {
        dist[other] = d - 1;
        q.push({dist[other], other});
      }
    }
  }
  
  vector<int> best(n + 1, 0);
  for (int i = 0; i < m; ++i) {
    Edge e = edges[i];
    best[e.v] = max(best[e.v], -dist[i]);
  }
  for (int i = 1; i <= n; ++i) {
    cout << best[i] << " ";
  }
}
